/*
 * Demonstrate the NSRL C++ class
 */

#include "config.h"

#include "bloom.h"
#include "sha1_t.h"

#include <stdio.h>
#include <sys/types.h>
#include <string.h>
#include <cstring>


int main(int argc,char **argv)
{
    int errors =0;
    NSRLBloom b;
    b.debug = 2;
    b.create(0,160,16,4,"A test bloom filter in memory");

    printf("Storing SHA1 values of even numbers into bloom filter...\n");
    for(int i=0;i<10;i+=2){
	char number[20];
	
	sprintf(number,"%d",i);
	
	sha1_t s((u_char *)number,strlen(number));
	b.add(s.sha1);
    }
    printf("Checking to make sure that odd numbers are not present and even numbers are present\n");
    for(int i=0;i<10;i++){
	char number[20];
	
	sprintf(number,"%d",i);

	sha1_t s((u_char *)number,strlen(number));
	bool present = b.query(s.sha1);
	bool even     = (i%2)==0;

	if(present != even){
	    printf("error: i=%d  present=%d even=%d\n",i,present,even);
	    errors++;
	}
    }
    printf("done\n");
    return errors;
}
